<?php
namespace BancoTalentos\Util;

use Zeedhi\Framework\Session\Session;

class BTParameters {
    /** @var Session */
    protected $session;

    public function __construct(Session $session)
    {
        $this->session = $session;
    }

    private function get($param) {
        return $this->session->get($param);
    }

    private function set(string $key, $value): void {
        $this->session->set($key, $value);
    }


    public function getCdoperador() {
        return $this->get('CDOPERADOR');
    }

    public function setCdOperador(string $cdOperador): void {
        $this->set('CDOPERADOR', $cdOperador);
    }


    public function getNmOperador() {
        return $this->get('NMOPERADOR');
    }

    public function setNmOperador(string $nmOperador) {
        $this->set('NMOPERADOR', $nmOperador);
    }


    public function getNrOrg() {
        return $this->get('NRORG');
    }

    public function setNrOrg(int $nrOrg): void {
        $this->set('NRORG', $nrOrg);
    }


    public function getNrOrgPadrao() {
        return $this->get('NRORG_PADRAO');
    }


    public function getNrParcNegocio(): string {
        return $this->get('NRPARCNEGOCIO');
    }

    public function setNrParcNegocio(int $nrParcNegocio): void {
        $this->set('NRPARCNEGOCIO', $nrParcNegocio);
    }
}
