<?php

namespace BancoTalentos\Util\FileServerClasses\Util;

class MyCurl {
    const CONTENT_TYPE_HEADER = "Content-Type: application/json";

    public static function post(
        string $url,
        array $jsonPayload,
        array $customHeaders = [],
        $toJson = true
    ) {
        $ch = curl_init();
        $defaults = array(
            CURLOPT_URL => $url,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => json_encode($jsonPayload),
            CURLOPT_HTTPHEADER => array_merge($customHeaders, array(self::CONTENT_TYPE_HEADER)),
            CURLOPT_RETURNTRANSFER => 1,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_CONNECTTIMEOUT => 10,
            CURLOPT_TIMEOUT => 30
        );

        curl_setopt_array($ch, $defaults);
        return self::doRequest($ch, $toJson);
    }

    public static function get(
        string $url,
        array $customHeaders = [],
        $toJson = true
    ) {
       
        $ch = curl_init();

        $defaults = array(
            CURLOPT_URL => $url,
            CURLOPT_POST => false,
            CURLOPT_HTTPHEADER => $customHeaders,
            CURLOPT_RETURNTRANSFER => 1,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_CONNECTTIMEOUT => 10,
            CURLOPT_TIMEOUT => 30
        );

        curl_setopt_array($ch, $defaults);
        return self::doRequest($ch, $toJson);
    }

    private static function doRequest(
        $ch,
        bool $toJson = true
    ) {
        $result = curl_exec($ch);
        $body = json_decode($result, true);
        $error = curl_error($ch);
        curl_close($ch);

        if (isset($body['error'])) {
            throw new \Exception($body['error']);
        }

        if (!empty($error)) {
            throw new \Exception($error);
        }

        if ($toJson) {
            return $body;
        }

        return $result;
    }
}