<?php

namespace tests\mocks;

use Doctrine\Persistence\ObjectRepository;

class ObjectRepositoryMock Implements ObjectRepository
{
    /* Structures created for testing */

    private $existingData;

    public function setExistingDataForTests(array $data = null) {
        $this->existingData = $data;
    }

    public function getExistingDataForTests(): ?array {
        return $this->existingData;
    }

    public function findInExistingDataBtCriteria(array $criteria) {
        return array_filter(
            $this->existingData,
            function ($item) use ($criteria) {
                foreach ($criteria as $criteriaItemName => $criteriaItemValue) {
                    $getMethod = 'get' . ucwords(strtolower($criteriaItemName));
                    if ($item->$getMethod() != $criteriaItemValue) {
                        return false;
                    }
                }

                return true;
            }
        );
    }

    /* Methods declared in ObjectRepository */

    public function find($id) { return $this->existingData; }

    public function findAll() { return $this->existingData; }

    public function findBy(array $criteria, ?array $orderBy = null, $limit = null, $offset = null) { return $this->existingData; }

    public function findOneBy(array $criteria) {
        $result = $this->findInExistingDataBtCriteria($criteria);
        return $result[0] ?? null;
    }

    public function getClassName() {}
}

interface_exists(\Doctrine\Common\Persistence\ObjectRepository::class);
